/*
// An example of overloading
//
*/

#include <iostream>

using namespace std ;

// define the function factorial with integer argument
int
factorial( int a ) {
  cout << "using factorial(int) with a = " << a << "\n" ;
  if ( a > 1 ) return a*factorial(a-1) ;
  else         return 1 ;
}

// define the function factorial with unsigned long integer argument
unsigned long
factorial( unsigned long a ) {
  cout << "using factorial(unsigned long) with a = " << a << "\n" ;
  if ( a > 1 ) return a*factorial(a-1) ;
  else         return 1 ;
}

int
main() {
  unsigned long ula = 10 ;
  int           ia  = 10 ;
  cout << factorial(ia) << "\n" ;
  cout << factorial(ula) << "\n" ;
  long b = factorial(ia) ;
  return 0 ;
}